/******************* FILE : wav_in.h *********************/


/****** NOTICE: LIMITATIONS ON USE AND DISTRIBUTION ********\

  This software is provided on an as-is basis, it may be 
  distributed in an unlimited fashion without charge provided
  that it is used for scholarly purposes - it is not for 
  commercial use or profit. This notice must remain unaltered. 

  Software by Dr Fred DePiero - CalPoly State University

\******************** END OF NOTICE ************************/




#ifndef INCLUDE_WAV_IN
#define INCLUDE_WAV_IN

#include "j2kaudiotype.h"

class WAV_OUT;

class WAV_IN
{

public:

   WAV_IN(const char *wav_file_name);    
   ~WAV_IN();
   
   // routine for reading one sample from a (previously loaded) wave file
   //  returns current sample as a short 
   sampletype read_current_input();


   // determines end-of-file condition, returns 1==true if more data ready
   int more_data_available();

   // returns number of samples in file
   long long get_num_samples();

   // reports number of channels (1==mono, 2==stereo)
   short get_num_channels();

   // reports the number of bits in each sample
   short get_bits_per_sample();

   // reports sample rate in Hz
   int get_sample_rate_hz();

protected:
      
   int fs_hz;
   short bits_per_sample;
   short num_ch;

   sampletype *g_wdata_in;//used to be short
   long long g_num_isamp;
   long long g_max_isamp;

   friend class WAV_OUT;
};

#endif

