/******************* FILE : wav_out.h *********************/


/****** NOTICE: LIMITATIONS ON USE AND DISTRIBUTION ********\

  This software is provided on an as-is basis, it may be 
  distributed in an unlimited fashion without charge provided
  that it is used for scholarly purposes - it is not for 
  commercial use or profit. This notice must remain unaltered. 

  Software by Dr Fred DePiero - CalPoly State University

\******************** END OF NOTICE ************************/




#ifndef INCLUDE_WAV_OUT
#define INCLUDE_WAV_OUT

#include "j2kaudiotype.h"

class WAV_IN;


class WAV_OUT
{

public:

   // create a new wav_out with given parameters
   //  note: soundcards typically support a limited range of values!
   //        hence the next constructor is safer: WAV_OUT(WAV_IN *wav);
   WAV_OUT(int fs_hz,short bits_per_sample,short num_ch);
   
   // create a wav_out with the same parameters as a given wav_in
   WAV_OUT(WAV_IN *wav_in);   

   ~WAV_OUT();
   
   // routine for writing one short output sample
   //  samples are stored in a buffer, until save_wave_file() is called
   //  returns 0 on success 
   int write_current_output(sampletype ooo);

   // routine for saving a wave file. 
   //  returns 0 on success, negative value on error 
   int save_wave_file(const char *wav_file_name);

protected:
      
   int fs_hz;
   short bits_per_sample;
   short num_ch;

   sampletype *g_wdata_out;
   long long g_num_osamp;
   long long g_max_osamp;

   friend class WAV_IN;
};

#endif


